using ICSSoft.Common;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ICSSoft.Entity;
using UFSoft.UBF.Util.Context;
using System.ServiceModel;
using www.ufida.org.EntityData;
using UFSoft.UBF.Exceptions1;
using ICS.WCF.Base;

namespace ICSSoft.APIApproveCompRpt
{
    public class ApproveCompRpt
    {
        private static log4net.ILog log = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        private static string connString = System.Configuration.ConfigurationManager.AppSettings["ERPConnStr"];
        private static string ERPDB = System.Configuration.ConfigurationManager.AppSettings["ERPDB"];
        /// <summary>
        /// 审核完工报告（外部通过API调用）
        /// </summary>
        /// <param name="infos"></param>
        /// <returns></returns>
        public bool Approve(List<ICSManufactureReceiveDoc> infos)
        {
            bool ResultFlag = false;
            try
            {
                bool b = false;
                //实例化代理类 
                UFIDAU9ISVMOIApproveCompleteRpt4ExternalSrvClient client = new UFIDAU9ISVMOIApproveCompleteRpt4ExternalSrvClient();
                //服务返回结果
                UFIDAU9ISVMOCompRptKeyDTOData[] returnValue;
                //返回异常信息，目前还没有使用此属性
                UFSoft.UBF.Exceptions.MessageBase[] returnMsg;
                //上下文信息
                object context;
                //UFSoft.UBF.Business.BusinessEntity.EntityKey dochead = new UFSoft.UBF.Business.BusinessEntity.EntityKey();
                //传入 参数
                UFIDAU9ISVMOCompRptKeyDTOData[] dOList;
                string OrgID = "";
                string orgsql = @"select ID from Base_Organization
                                          where Code='{0}'";
                orgsql = string.Format(orgsql, infos[0].WorkPoint);
                DataTable orgdt = DBhlper.Query(orgsql, Appconfig.GetU9ConnStr());
                if (orgdt.Rows.Count != 0)
                {
                    OrgID = orgdt.Rows[0]["ID"].ToString();
                }
                else
                {
                    throw new Exception("传入组织编码错误!");
                }
                //给上下文信息赋值
                context = CreateContextObj(OrgID);
                //给传入参数赋值
                List<UFIDAU9ISVMOCompRptKeyDTOData> CodeList = new List<UFIDAU9ISVMOCompRptKeyDTOData>();

                foreach (ICSManufactureReceiveDoc item in infos)
                {
                    UFIDAU9ISVMOCompRptKeyDTOData dochead = new UFIDAU9ISVMOCompRptKeyDTOData();
                    dochead.m_operateType = true;
                    //dochead.m_org = new UFIDAU9CBOPubControllerCommonArchiveDataDTOData();

                    dochead.m_docNo = item.MRCVCode;
                    dochead.m_iD = GetTypeID(item.MRCVCode, OrgID);
                    dochead.m_org = new UFIDAU9CBOPubControllerCommonArchiveDataDTOData();
                    dochead.m_org.m_iD = long.Parse(OrgID);
                    CodeList.Add(dochead);
                }
                dOList = CodeList.ToArray();
                //服务调用

                (client.Endpoint.Binding as BasicHttpBinding).MaxReceivedMessageSize = int.MaxValue;
                (client.Endpoint.Binding as BasicHttpBinding).MaxBufferSize = int.MaxValue;

                //bool m=SetBinCode(BinCode,DocCode);//赋值库位
                //b = m;
                returnValue = client.Do(out returnMsg, context, dOList, false);

                foreach (UFIDAU9ISVMOCompRptKeyDTOData returnInfo in returnValue)
                {
                    if (returnInfo.m_operateResult == false)
                    {
                        throw new Exception(returnInfo.m_errorMsg);
                    }
                    ResultFlag = true;
                }
            }
            catch (Exception ex)
            {
                log.Error(ex.Message);
                throw new Exception(ex.Message);
            }
            return ResultFlag;
        }
        /// <summary>
        /// 审核完工报告（接口内部调用，如：创建退料单后调用审核单据）
        /// </summary>
        /// <param name="DocNOList"></param>
        /// <param name="OrgCode"></param>
        /// <returns></returns>
        public bool Approve(List<string> DocNOList, string OrgCode)
        {
            bool ResultFlag = false;
            try
            {
                bool b = false;
                //实例化代理类 
                UFIDAU9ISVMOIApproveCompleteRpt4ExternalSrvClient client = new UFIDAU9ISVMOIApproveCompleteRpt4ExternalSrvClient();
                //服务返回结果
                UFIDAU9ISVMOCompRptKeyDTOData[] returnValue;
                //返回异常信息，目前还没有使用此属性
                UFSoft.UBF.Exceptions.MessageBase[] returnMsg;
                //上下文信息
                object context;
                //UFSoft.UBF.Business.BusinessEntity.EntityKey dochead = new UFSoft.UBF.Business.BusinessEntity.EntityKey();
                //传入 参数
                UFIDAU9ISVMOCompRptKeyDTOData[] dOList;
                string OrgID = "";
                string orgsql = @"select ID from Base_Organization
                                          where Code='{0}'";
                orgsql = string.Format(orgsql, OrgCode);
                DataTable orgdt = DBhlper.Query(orgsql, Appconfig.GetU9ConnStr());
                if (orgdt.Rows.Count != 0)
                {
                    OrgID = orgdt.Rows[0]["ID"].ToString();
                }
                else
                {
                    throw new Exception("审核传入组织编码错误!");
                }
                //给上下文信息赋值
                context = CreateContextObj(OrgID);
                //给传入参数赋值
                List<UFIDAU9ISVMOCompRptKeyDTOData> CodeList = new List<UFIDAU9ISVMOCompRptKeyDTOData>();

                foreach (string DocNO in DocNOList)
                {
                    UFIDAU9ISVMOCompRptKeyDTOData dochead = new UFIDAU9ISVMOCompRptKeyDTOData();
                    dochead.m_operateType = true;
                    //dochead.m_org = new UFIDAU9CBOPubControllerCommonArchiveDataDTOData();

                    dochead.m_docNo = DocNO;
                    dochead.m_iD = GetTypeID(DocNO, OrgID);
                    dochead.m_org = new UFIDAU9CBOPubControllerCommonArchiveDataDTOData();
                    dochead.m_org.m_iD = long.Parse(OrgID);
                    CodeList.Add(dochead);
                }
                dOList = CodeList.ToArray();
                //服务调用

                (client.Endpoint.Binding as BasicHttpBinding).MaxReceivedMessageSize = int.MaxValue;
                (client.Endpoint.Binding as BasicHttpBinding).MaxBufferSize = int.MaxValue;

                //bool m=SetBinCode(BinCode,DocCode);//赋值库位
                //b = m;
                returnValue = client.Do(out returnMsg, context, dOList, false);

                foreach (UFIDAU9ISVMOCompRptKeyDTOData returnInfo in returnValue)
                {
                    if (returnInfo.m_operateResult == false)
                    {
                        throw new Exception(returnInfo.m_errorMsg);
                    }
                    ResultFlag = true;
                }
            }
            catch (Exception ex)
            {
                log.Error(ex.Message);
                throw new Exception(ex.Message);
            }
            return ResultFlag;
        }

        private static long GetTypeID(string docTypeCode, string OrgID)
        {
            string sql = @"select ID from MO_CompleteRpt where DocNo='" + docTypeCode + "' AND Org='" + OrgID + "' ";
            DataTable dt = DBhlper.Query(sql, Appconfig.GetU9ConnStr());
            if (dt.Rows.Count > 0)
            {
                return long.Parse(dt.Rows[0][0].ToString());
            }
            else
            {
                return 0;
            }
        }

        #region 给上下文信息赋值
        /// <summary>
        /// 给上下文信息赋值
        /// </summary>
        /// <returns></returns>
        private static ThreadContext CreateContextObj(string OrgID)
        {
            // 实例化应用上下文对象
            ThreadContext thContext = new ThreadContext();


            System.Collections.Generic.Dictionary<object, object> ns = new Dictionary<object, object>();
            ns.Add("OrgID", OrgID);
            ns.Add("UserID", ConfigurationManager.AppSettings["userID"].ToString());
            ns.Add("UserCode", ConfigurationManager.AppSettings["userCode"].ToString());
            ns.Add("Datetime", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"));
            ns.Add("CultureName", ConfigurationManager.AppSettings["cultureName"].ToString());
            ns.Add("EnterpriseID", ConfigurationManager.AppSettings["enterpriseID"].ToString());
            ns.Add("DefaultCultureName", ConfigurationManager.AppSettings["cultureName"].ToString());
            thContext.nameValueHas = ns;

            return thContext;
        }
        #endregion
    }
}
